<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Spring | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="微服务：微服务的概念源于2014年3月Martin Fowler所写的一篇文章Microservices” 。微服务架构是一种架构模式，它提倡将单一应用程序划分成组小的服务.服务之间互相协调、互相配合，为用户提供最终价值。每个服务运行在其独立的进程中，服务与服务间采用轻量级的通信机制互相沟通(通常是基于HTTP的RESTful API).每个服务都围绕具体业务进行构建，并且能够被独立地部署到生产环">
<meta property="og:type" content="article">
<meta property="og:title" content="Spring">
<meta property="og:url" content="http://example.com/2021/02/24/Spring/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="微服务：微服务的概念源于2014年3月Martin Fowler所写的一篇文章Microservices” 。微服务架构是一种架构模式，它提倡将单一应用程序划分成组小的服务.服务之间互相协调、互相配合，为用户提供最终价值。每个服务运行在其独立的进程中，服务与服务间采用轻量级的通信机制互相沟通(通常是基于HTTP的RESTful API).每个服务都围绕具体业务进行构建，并且能够被独立地部署到生产环">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-02-24T07:43:00.000Z">
<meta property="article:modified_time" content="2021-02-24T09:23:54.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/02/24/Spring/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-02-24 17:23:54'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Spring</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-02-24T07:43:00.000Z" title="发表于 2021-02-24 15:43:00">2021-02-24</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-02-24T09:23:54.000Z" title="更新于 2021-02-24 17:23:54">2021-02-24</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Spring/">Spring</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><p>微服务：<br>微服务的概念源于2014年3月Martin Fowler所写的一篇文章Microservices” 。<br>微服务架构是一种架构模式，它提倡将单一应用程序划分成组小的服务.服务之间互相协调、互相配合，为用户提供最终价值。每个服务运行在其独立的进程中，服务与服务间采用轻量级的通信机制互相沟通(通常是基于HTTP的RESTful API).每个服务都围绕具体业务进行构建，并且能够被独立地部署到生产环境、类生产环境等另外，应尽量避免统的集中式的服务理机制.对具体的一个服务而言，应根据业务上下文，选择合适的语言、工具对其进行构建。微服务是种架构风格，一个大型复杂软件应用由一 个或多个微服务组成。系统中的各个微服务可被独立部署，各个微服务之间是松精合的。每个微服务仅关注于完成件任务并很好地完成该任务。在所有情况下，每个任务代表着个小的业务能力。</p>
<p>概述<br>spring cloud为开发人员提供了快速构建分布式系统中的一些常见模式的工具(例如配置管理服务发现、断路由、智能路由、微服务、控制总线)。分布式系统的协调导致了样板模式，使用spring cloud开发人员可以快速地支持实现这些模式的服务</p>
<p>背景<br>应用框架的演变<br>1.单一应用架构<br>2.垂直应用架构<br>3.分布式服务架构<br>4.流动计算架构</p>
<h1 id="spring框架"><a href="#spring框架" class="headerlink" title="spring框架"></a>spring框架</h1><h2 id="spring-boot"><a href="#spring-boot" class="headerlink" title="spring boot"></a>spring boot</h2><p>Spring Boot是由Pivotal团队提供的全新框架,其设计目的是用来简化新Spring应用的打始措建以及开发过程。该框架使用了特定的方式来进行配置从而使开发人员不再需要定义样板化的配置。Spring Boot不是什么新的框架,它默认配置了很多框架的使用方式，就像maven整合了所有的jar包，Spring Boot整合了所有的框架(不知道这样比喻是否合适。Spring Boot简化了基于Spring的应用开发，通过少量的代码就能创建一个独立的、 产品级别的Spring应用。Spring Boot为Spring平台及第方库提供开箱即用的设置,这样你就可以有条不紊地开始。<br>Spring Boot的核心思想就是约定大于配置，多数Spring Boot应用只需要很少的Spring配置。采用Spring Boot可以大大的简化你的开发模式,所有你想集成的常用框架，它都有对应的组件支持。</p>
<h2 id="spring-cloud"><a href="#spring-cloud" class="headerlink" title="spring cloud"></a>spring cloud</h2><p>Spring Cloud是一系列框架的有序集合。它利用Spring Boot的开发便利性巧妙地简化了分布式系统基础设施的开发.如服务发现注册配置中心消息总线负载均衡断路器数据监控等，都可以用Sping Boo的开发风格做到键启动和部署。Spring Coud并没有重复制造轮子:它只是将目前各家公司开发的比较成熟经得起考验的服务框架很合起来;通过Spring B风格进行再封装屏蔽掉了复杂的开发工具包。开爱和实视原理，最终给开发者留出了 喜简单易懂易都着和易维护的分布式系统</p>
<p>特性<br>●spring cloud专注于提供良好的开箱即用经验的典型用例和可扩展性机制覆盖<br>●分布式/版本化配置.服务注册和发现.路由<br>●service-to-service调用.负载均衡<br>●断路由<br>●分布式消息传递</p>
<h1 id="组件"><a href="#组件" class="headerlink" title="组件"></a>组件</h1><h2 id="spring-cloud-config"><a href="#spring-cloud-config" class="headerlink" title="spring cloud config"></a>spring cloud config</h2><p>●远程配置服务。<br>●远程配置是每个都必不可少的中间件,远程配置的特点一般需要:多节点主备、配置化动态修改、配置本地化缓存、动态修改的实时推送等。<br>● config允许配置文件放在git上或者svn上，和spring boot的集成非常容易，但是缺点就是修改了git上的配置以后，只能个个的请求每个service的接口 ,让他们去更新配置，需要配合消息总线和队列结合使用</p>
<h2 id="spring-cloud-bus"><a href="#spring-cloud-bus" class="headerlink" title="spring cloud bus"></a>spring cloud bus</h2><p>●事件消息总线，用于在集群(例如，配置变化事件)中传播状态变化。经常与SpringCloud Config联合使用。<br>●spring cloud config本身不能向注册过来的服务提供实时更新的推送。比如我们配置放在了git上，那么当修改github上配置内容的时候，最多可以配置webhook到台config-server上，但是config-server自己不会将配置更新实时推送到各个服务上。<br>● bus的作用就是将大家链接在 条总线上，这条线上的所有server共享状态,当webhook到bus.上的某台server的时候 ,其他server也会收到相同的hook状态。但是bus的使用需要依赖于MQ, bus直接继承了RabbitMq &amp; kafka ,只需要在Sspring中直接配置地址即可</p>
<h2 id="spring-cloud-bus-1"><a href="#spring-cloud-bus-1" class="headerlink" title="spring cloud bus"></a>spring cloud bus</h2><p>●事件消息总线，用于在集群(例如，配置变化事件)中传播状态变化。经常与SpringCloud Config联合使用。<br>●spring cloud config本身不能向注册过来的服务提供实时更新的推送。比如我们配雪放在了git，那么当修改github上配置内容的时候，最多可以配置webhook到一台config-server.上，但是config-server自己不会将配置更新实时推送到各个服务上。<br>●bus的作用就是将大家链接在一 条总线上，这条线上的所有server共享状态，当webhook到bus上的某一台server的时候 ,其他server也会收到相同的hook状态。但是bus的使用需要依赖于MQ, bus直接继承了RabbitMq &amp; kafka,只需要在spring中直接配置地址即可</p>
<h2 id="eureka"><a href="#eureka" class="headerlink" title="eureka"></a>eureka</h2><p>●spring cloud的服务发现组件。<br>●eureka负责服务注册和服务发现，为了高可用，一般需要多 个eureka<br>serverd相互注册，组成集群。Eureka Server的同步遵循着个非常简单的原则:只要有一条边将节点连接,就可以进行信息传播与同步。<br>●eureka内部对于注册的service主要通过心跳来监控service是否已经挂掉,默认心跳时间是15s。这就意味着，当个服务提供方挂掉以后，服务订阅者最长可能30s以后才发现。<br>●service启动连上eureka之后，会同步份服务列表到本地缓存 ,服务注册有更新时, eureka会推送到每个service。<br>● eureka也会有一些策略防止由于某个服务所在网络的不稳定导致的所有服务心跳停止的雪崩现象。<br>●eureka自带web页面，在页面上能看到所有的服务注册情况和eureka集群状态。<br>● eureka支持服务自己主动下掉自己:请sevice的下列地址.可以让服务从eureka上下掉自己，同时service进程也会自己停掉自己。curd -H</p>
<h2 id="consul"><a href="#consul" class="headerlink" title="consul"></a>consul</h2><p>●也是一个服务发现工具，而且自带key-value存储服务健康检查和web页面。<br>●能联行首方dcer镜像，直接使用docker cnsu集群用户服务发现的话.运维成本会直线下降</p>
<h2 id="ribbon"><a href="#ribbon" class="headerlink" title="ribbon"></a>ribbon</h2><p>●客户端负载均衡组件。<br>●服务发现以后，每个service在本地知道自己要调用的服务有多少台机器，机器的ip是什么，端口号是多少,那这个service在本地需要有一个负载均衡策略，为每一次请求选择一台目标机器进行调用,而ribbon做的就是负载均衡策略的选择。<br>● ribbon提供了多种负载均衡策略,包括BestAvailableRule.<br>AvailabilityFilteringRuleWeightedResponseTimeRule. RetryRule、 RoundRobinRule、 RandomRule、<br>ZoneAvoidanceRule等,没记错的话,默认是ZoneAvoidanceRule.当然，也可以自定义自己的负载均衡策略,比如被调用服务需要灰度发布或者A/B测试的话,就可以在ribbon这一-层做自定义。</p>
<h2 id="feign"><a href="#feign" class="headerlink" title="feign"></a>feign</h2><p>●声明式、模板化的HTTP客户端。<br>●微服务之间的调用本质还是http请求,如果对于每个请求都需要写请求代码，增加请求参数，同时对请求结果做处理，就会存在大量重复工作，而feign非常优雅的帮助我们解决了这个问题，只需要定义一个interface ,fegin就知道http请求的时候参数应该如何设置。同时, feign也集成了ribbon，只要在微服务中依赖了ribbon , feign默认会使用ribbon定义的负载均衡策略。<br>●feign并不是仅只能使用在有eureka或者ribbon的微服务系统中,任何系统中，只要涉及到http调用第三方服务，都可以使用feign帮我们解决http请求的代码重复编写</p>
<h2 id="hystrix"><a href="#hystrix" class="headerlink" title="hystrix"></a>hystrix</h2><p>●断路器，类似于物理电路图中的断路器。<br>●正常情况下，当整个服务环境中，某个服务提供方由于网络原因、数据库原因或者性能原因等,造成响应很慢的话.调用方就有可能短时间内累计大量的请求线程，最终造成调用方down,甚至整个系统崩溃。而加入hystrix之后，如果hystrix发现某个服务的某台机器调用非常缓慢或者多次调用失败，就会短时间内把这条路断掉,所有的请求都不会再发到这台机器上。<br>●如果某个服务所有的机器都挂了, hystrix会迅速失败,马上返回，保证被调用方不会有大量的线程堆积。<br>●Feign默认集成了hystrix. *上面有提到,使用eureka时，当个服务提供方挂掉以后，服务订阅者最长可能3s以后才知道那这30s就会出现大的调用失败。如果在系统里面集成了hystix,就会马上把挂掉的这台服务提供方断路掉，让请求不再转发到这台机器上，大量减少调用失败。<br>●hystrix执行断坚操作议后 并不表示这条路就永远断了，而是会定时间间隔内缓慢尝试去请求这条路，如果能请求成功.断路就会恢复。</p>
<h2 id="zuul"><a href="#zuul" class="headerlink" title="zuul"></a>zuul</h2><p>●是个网关组件提供动态路由监控弹性安全等边缘服务的推架。<br>●安简华量Fropetis文件 不需要与具体的代码就可以实现将请求转发到相应的服务上去。还可以定制化些fiter做验证 隔离限流文件处理等切面，对于网关来说，使用zuul能减少大的代码。</p>
<h2 id="turbine"><a href="#turbine" class="headerlink" title="turbine"></a>turbine</h2><p>●是聚合服务器发送事件流数据的一个工具,用来监控集群Fhystrix的metrics情况<br>●在复杂的分布式系统中，相同服务的节点经常需要部署上百甚至上千个，很多时候，运维人员希望能够把相同服务的节点状态以一个 整体集群的形式展现出来，这样可以更好的把握整个系统的状态。<br>●turbine提供把多个hystrix.stream的内容聚合为一个数据源供Dashboard展示</p>
<h2 id="Spring-Cloud-Starters"><a href="#Spring-Cloud-Starters" class="headerlink" title="Spring Cloud Starters"></a>Spring Cloud Starters</h2><p>●spring boot熱插拔、提供默圦配置、幵箱即用的依頼。<br>●starter 是spring bpot框架非常基咄的部分。可以自定义starter</p>
<h1>端口信息</h1>

<blockquote>
<p>8080：服务注册中心的端口<br>9000：生产者端口<br>9001：消费者端口<br>8888：网关的端口</p>
</blockquote>
<h1 id="服务器信息"><a href="#服务器信息" class="headerlink" title="服务器信息"></a>服务器信息</h1><table>
<thead>
<tr>
<th align="center">IP</th>
<th align="center">服务</th>
</tr>
</thead>
<tbody><tr>
<td align="center">1.1.1.3</td>
<td align="center">maven</td>
</tr>
<tr>
<td align="center">1.1.1.4</td>
<td align="center">maven</td>
</tr>
</tbody></table>
<h2 id="部署maven"><a href="#部署maven" class="headerlink" title="部署maven"></a>部署maven</h2><blockquote>
<p><code>两台节点都部署，过程略……</code></p>
</blockquote>
<h2 id="部署Eureka注册中心"><a href="#部署Eureka注册中心" class="headerlink" title="部署Eureka注册中心"></a>部署Eureka注册中心</h2><blockquote>
<p><code>两台节点都部署</code></p>
</blockquote>
<h3 id="解压软件包"><a href="#解压软件包" class="headerlink" title="解压软件包"></a>解压软件包</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">tar zxf spring-cloud-examples.tar.gz -C &#x2F;usr&#x2F;local&#x2F;</span><br><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;</span><br><span class="line">cd spring-cloud-eureka&#x2F;spring-cloud-eureka</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.properties</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-204.png" alt="upload successful"></p>
<h3 id="项目打包"><a href="#项目打包" class="headerlink" title="项目打包"></a>项目打包</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h3 id="构建完之后操作"><a href="#构建完之后操作" class="headerlink" title="构建完之后操作"></a>构建完之后操作</h3><p>两台节点构建完成之后执行以下操作开启服务注册中心</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;spring-cloud-eureka-0.0.1-SNAPSHOT.jar</span><br><span class="line"># 执行过后会占用终端，不要终止</span><br></pre></td></tr></table></figure>
<h3 id="打开新终端"><a href="#打开新终端" class="headerlink" title="打开新终端"></a>打开新终端</h3><p>激活新终端的环境变量文件并放行端口、沙盒</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">netstat -lnpt | grep 8080</span><br><span class="line">firewall-cmd --add-port&#x3D;8000&#x2F;tcp</span><br><span class="line">setenforce 0</span><br></pre></td></tr></table></figure>
<blockquote>
<p>访问<code>1.1.1.3:8080</code></p>
</blockquote>
<p><img src="/images/pasted-205.png" alt="upload successful"></p>
<blockquote>
<p>访问<code>1.1.1.4:8080</code></p>
</blockquote>
<p><img src="/images/pasted-206.png" alt="upload successful"></p>
<h2 id="部署Producer生产者"><a href="#部署Producer生产者" class="headerlink" title="部署Producer生产者"></a>部署Producer生产者</h2><p>第一台节点打开新终端<br>构建生产者，服务注册与发现中心</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;eureka-producer-consumer&#x2F;spring-clound-porducer&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.properties</span><br><span class="line">spring.application.name&#x3D;spring-cloud-producer</span><br><span class="line">server.port&#x3D;9000	&#x2F;&#x2F;生产者端口</span><br><span class="line">eureka.client.serviceUrl.defaultZone&#x3D;http:&#x2F;&#x2F;1.1.1.3:8080&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8080&#x2F;eureka&#x2F;	&#x2F;&#x2F;生产者将信息注册到指定的URL所对应的服务注册中心</span><br></pre></td></tr></table></figure>
<h3 id="修改HelloController文件"><a href="#修改HelloController文件" class="headerlink" title="修改HelloController文件"></a>修改HelloController文件</h3><p>第一台节点<br>作为两个节点的区分</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">vi src&#x2F;main&#x2F;java&#x2F;com&#x2F;neo&#x2F;controller&#x2F;HellpController.java</span><br><span class="line">修改：</span><br><span class="line">        return &quot;hello &quot;+name+&quot;，this is first hahaha\n&quot;;</span><br></pre></td></tr></table></figure>
<h3 id="项目打包-1"><a href="#项目打包-1" class="headerlink" title="项目打包"></a>项目打包</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h3 id="节点二打开新终端"><a href="#节点二打开新终端" class="headerlink" title="节点二打开新终端"></a>节点二打开新终端</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br></pre></td><td class="code"><pre><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;eureka-producer-consumer&#x2F;spring-cloud-producer&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.properties</span><br><span class="line">spring.application.name&#x3D;spring-cloud-producer</span><br><span class="line">server.port&#x3D;9000</span><br><span class="line">eureka.client.serviceUrl.defaultZone&#x3D;http:&#x2F;&#x2F;1.1.1.3:8080&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8080&#x2F;eureka&#x2F;</span><br><span class="line"></span><br></pre></td></tr></table></figure>
<h3 id="项目打包-2"><a href="#项目打包-2" class="headerlink" title="项目打包"></a>项目打包</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h3 id="生产和消费构建完成执行操作"><a href="#生产和消费构建完成执行操作" class="headerlink" title="生产和消费构建完成执行操作"></a>生产和消费构建完成执行操作</h3><p>两台节点都构建完成后执行以下操作开启生产者的9000端口</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;eureka-producer-consumer&#x2F;spring-cloud-producer</span><br><span class="line">java -jar target&#x2F;spring-cloud-producer-0.0.1-SNAPSHOT.jar</span><br><span class="line">netstat -lnpt | grep 9000</span><br></pre></td></tr></table></figure>
<h3 id="放行防火墙"><a href="#放行防火墙" class="headerlink" title="放行防火墙"></a>放行防火墙</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">放行9000端口防火墙、沙盒</span><br><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">firewall-cmd --add-port&#x3D;9000&#x2F;tcp</span><br><span class="line">setenforce 0</span><br></pre></td></tr></table></figure>
<p>执行后，再次打开浏览器刷新一下（这里就会显示8000端口和9000端口）</p>
<p><img src="/images/pasted-207.png" alt="upload successful"></p>
<p>最后验证<br>/hello？name=haha（haha这个名字随意指定）</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl 1.1.1.3:9000&#x2F;hello?name&#x3D;haha</span><br><span class="line">hello haha，this is first hahaha</span><br><span class="line">curl 1.1.1.4:9000&#x2F;hellp?name&#x3D;xixi</span><br><span class="line">hello xixi，this is first messge</span><br></pre></td></tr></table></figure>
<h2 id="部署Consumer消费者"><a href="#部署Consumer消费者" class="headerlink" title="部署Consumer消费者"></a>部署Consumer消费者</h2><h3 id="节点一"><a href="#节点一" class="headerlink" title="节点一"></a>节点一</h3><h4 id="修改配置文件"><a href="#修改配置文件" class="headerlink" title="修改配置文件"></a>修改配置文件</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;eureka-producer-consumer&#x2F;spring-cloud-consumer </span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.properties</span><br><span class="line">eureka.client.serviceUrl.defaultZone&#x3D;http:&#x2F;&#x2F;1.1.1.3:8000&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8000&#x2F;eureka&#x2F;</span><br></pre></td></tr></table></figure>
<h4 id="项目打包-3"><a href="#项目打包-3" class="headerlink" title="项目打包"></a>项目打包</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h4 id="运行消费者，开启9001端口"><a href="#运行消费者，开启9001端口" class="headerlink" title="运行消费者，开启9001端口"></a>运行消费者，开启9001端口</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;spring-cloud-consumer-0.0.1-SNAPSHOT.jar</span><br><span class="line">netstat -lnpt | grep 9001</span><br></pre></td></tr></table></figure>
<p>打开另一个终端并放行防火墙的9001端口、沙盒</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">firewall-cmd --add-port&#x3D;9001&#x2F;tcp</span><br><span class="line">setenforce 0</span><br></pre></td></tr></table></figure>
<p>再次打开浏览器，查看9001端口是否存在</p>
<p><img src="/images/pasted-208.png" alt="upload successful"></p>
<h3 id="节点二"><a href="#节点二" class="headerlink" title="节点二"></a>节点二</h3><h4 id="访问消费者端口"><a href="#访问消费者端口" class="headerlink" title="访问消费者端口"></a>访问消费者端口</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl http:&#x2F;&#x2F;1.1.1.3:9001&#x2F;hello&#x2F;haha</span><br><span class="line">hello haha，this is first messge</span><br><span class="line">curl http:&#x2F;&#x2F;1.1.1.3:9001&#x2F;hello&#x2F;haha</span><br><span class="line">hello haha，this is first hahaha</span><br></pre></td></tr></table></figure>
<blockquote>
<p>haha定义的是一个名字，访问时反馈的名字</p>
</blockquote>
<p>不断刷新会变换生产者的返回信息，是因为Spring Cloud的Ribbon负载均衡组件的作用进行集群轮询</p>
<h2 id="部署网关zuul"><a href="#部署网关zuul" class="headerlink" title="部署网关zuul"></a>部署网关zuul</h2><h3 id="节点一-1"><a href="#节点一-1" class="headerlink" title="节点一"></a>节点一</h3><h4 id="修改配置文件-1"><a href="#修改配置文件-1" class="headerlink" title="修改配置文件"></a>修改配置文件</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-cloud-zuul&#x2F;spring-cloud-zuul&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.properties</span><br><span class="line">修改注册中心ip</span><br><span class="line">eureka.client.service-url.defaultZone&#x3D;http:&#x2F;&#x2F;1.1.1.3:8000&#x2F;eureka,http:&#x2F;&#x2F;1.1.1.4:8000&#x2F;eureka</span><br><span class="line"></span><br><span class="line"># 释义</span><br><span class="line">#是否开启重试功能，微服务不可用时是否重试</span><br><span class="line">zuul.retryable&#x3D;true</span><br><span class="line">#对当前服务的重试次数</span><br><span class="line">ribbon.MaxAutoRetries&#x3D;2</span><br><span class="line">#切换相同Server的次数</span><br><span class="line">ribbon.MaxAutoRetriesNextServer&#x3D;0</span><br></pre></td></tr></table></figure>
<h4 id="项目打包-4"><a href="#项目打包-4" class="headerlink" title="项目打包"></a>项目打包</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h4 id="运行网关8888端口"><a href="#运行网关8888端口" class="headerlink" title="运行网关8888端口"></a>运行网关8888端口</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;spring-cloud-zuul-1.0.0.BUILD-SNAPSHOT.jar</span><br></pre></td></tr></table></figure>
<h4 id="放行防火墙-1"><a href="#放行防火墙-1" class="headerlink" title="放行防火墙"></a>放行防火墙</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">firewall-cmd --add-port&#x3D;8888&#x2F;tcp</span><br><span class="line">setenforce 0</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-209.png" alt="upload successful"></p>
<h3>刷新</h3>

<p><img src="/images/pasted-210.png" alt="upload successful"><br>8888端口启动完成</p>
<h3 id="节点二-1"><a href="#节点二-1" class="headerlink" title="节点二"></a>节点二</h3><h4 id="访问网关端口"><a href="#访问网关端口" class="headerlink" title="访问网关端口"></a>访问网关端口</h4><p>访问多次实现轮询效果（必须带有token值，可随便写）</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">hello zx，this is first messge</span><br><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">hello zx，this is first hahaha</span><br></pre></td></tr></table></figure>
<h3 id="模拟故障"><a href="#模拟故障" class="headerlink" title="模拟故障"></a>模拟故障</h3><h4 id="断掉节点二的9000端口的生产者"><a href="#断掉节点二的9000端口的生产者" class="headerlink" title="断掉节点二的9000端口的生产者"></a>断掉节点二的9000端口的生产者</h4><p>再次访问</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">The service is unavailable	&#x2F;&#x2F;这是在重试中……</span><br></pre></td></tr></table></figure>
<p>再次访问</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">hello zx，this is first hahaha</span><br><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">hello zx，this is first hahaha</span><br></pre></td></tr></table></figure>
<p>不会显示轮询效果，因为节点二的生产者中断</p>
<h4 id="开启节点二的9000端口"><a href="#开启节点二的9000端口" class="headerlink" title="开启节点二的9000端口"></a>开启节点二的9000端口</h4><p>等待几秒钟，让它进行重试<br>再次访问，就会实现轮询效果</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">hello zx，this is first messge</span><br><span class="line">curl &#39;http:&#x2F;&#x2F;1.1.1.3:8888&#x2F;spring-cloud-producer&#x2F;hello?name&#x3D;zx&amp;token&#x3D;123&#39;</span><br><span class="line">hello zx，this is first hahaha</span><br></pre></td></tr></table></figure>
<h4 id="重新启动消费者9001端口"><a href="#重新启动消费者9001端口" class="headerlink" title="重新启动消费者9001端口"></a>重新启动消费者9001端口</h4><p>节点二访问</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl http:&#x2F;&#x2F;1.1.1.3:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first hahaha</span><br><span class="line">curl http:&#x2F;&#x2F;1.1.1.3:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first messge</span><br></pre></td></tr></table></figure>
<h2 id="部署hystrix熔断器"><a href="#部署hystrix熔断器" class="headerlink" title="部署hystrix熔断器"></a>部署hystrix熔断器</h2><h3 id="节点一修改配置文件"><a href="#节点一修改配置文件" class="headerlink" title="节点一修改配置文件"></a>节点一修改配置文件</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-cloud-hystrix&#x2F;spring-cloud-consumer-hystrix&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.properties</span><br><span class="line"># 同样修改注册中心的集群地址</span><br><span class="line">eureka.client.serviceUrl.defaultZone&#x3D;http:&#x2F;&#x2F;1.1.1.3:8000&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8000&#x2F;eureka&#x2F;</span><br></pre></td></tr></table></figure>
<h3 id="项目打包-5"><a href="#项目打包-5" class="headerlink" title="项目打包"></a>项目打包</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h3 id="启动熔断器（带有熔断机制的消费者）"><a href="#启动熔断器（带有熔断机制的消费者）" class="headerlink" title="启动熔断器（带有熔断机制的消费者）"></a>启动熔断器（带有熔断机制的消费者）</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;spring-cloud-consumer-hystrix-0.0.1-SNAPSHOT.jar</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-211.png" alt="upload successful"></p>
<p>验证访问，轮询效果</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first hahaha</span><br><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first messge</span><br></pre></td></tr></table></figure>
<p>断开节点一的网络信息，再次访问（反馈消息发送失败）</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this messge send failed</span><br></pre></td></tr></table></figure>
<p>等待几秒钟，再次访问（多次访问只会反馈节点二的信息，不会在接收节点一的信息）</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first hahaha</span><br><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first hahaha</span><br></pre></td></tr></table></figure>
<p>恢复节点一的网络信息，等待几秒再次访问，就又会实现轮询效果</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first hahaha</span><br><span class="line">curl http:&#x2F;&#x2F;1.1.1.4:9001&#x2F;hello&#x2F;zx</span><br><span class="line">hello zx，this is first messge</span><br></pre></td></tr></table></figure>
<h2 id="部署zipkin链路追踪"><a href="#部署zipkin链路追踪" class="headerlink" title="部署zipkin链路追踪"></a>部署zipkin链路追踪</h2><blockquote>
<p>部署前需要关掉之前启动的网关和生产者端口</p>
</blockquote>
<h3 id="修改配置文件-2"><a href="#修改配置文件-2" class="headerlink" title="修改配置文件"></a>修改配置文件</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-cloud-sleuth-zipkin&#x2F;zipkin-server&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.yml</span><br><span class="line">defaultZone: http:&#x2F;&#x2F;1.1.1.3:8000&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8000&#x2F;eureka&#x2F;</span><br></pre></td></tr></table></figure>
<h3 id="项目打包-6"><a href="#项目打包-6" class="headerlink" title="项目打包"></a>项目打包</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h3 id="开启zipkin"><a href="#开启zipkin" class="headerlink" title="开启zipkin"></a>开启zipkin</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;zipkin-server-1.0.0.BUILD-SNAPSHOT.jar</span><br></pre></td></tr></table></figure>
<p>打开eureka浏览器查看服务是否注册</p>
<p><img src="/images/pasted-212.png" alt="upload successful"></p>
<h3 id="部署生产者"><a href="#部署生产者" class="headerlink" title="部署生产者"></a>部署生产者</h3><h4 id="节点一-2"><a href="#节点一-2" class="headerlink" title="节点一"></a>节点一</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-cloud-sleuth-zipkin&#x2F;spring-cloud-producer&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.yml</span><br><span class="line">修改：</span><br><span class="line">base-url: http:&#x2F;&#x2F;1.1.1.3:9000</span><br><span class="line">defaultZone: http:&#x2F;&#x2F;1.1.1.3:8000&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8000&#x2F;eureka&#x2F;</span><br></pre></td></tr></table></figure>
<h4 id="项目打包-7"><a href="#项目打包-7" class="headerlink" title="项目打包"></a>项目打包</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h4 id="启动生产者"><a href="#启动生产者" class="headerlink" title="启动生产者"></a>启动生产者</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;spring-cloud-producer-1.0.0.BUILD-SNAPSHOT.jar</span><br></pre></td></tr></table></figure>
<h3 id="部署网关"><a href="#部署网关" class="headerlink" title="部署网关"></a>部署网关</h3><h4 id="节点一-3"><a href="#节点一-3" class="headerlink" title="节点一"></a>节点一</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-cloud-sleuth-zipkin&#x2F;spring-cloud-zuul&#x2F;</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.yml</span><br><span class="line">修改：</span><br><span class="line">base-url：http:&#x2F;&#x2F;1.1.1.3:9000</span><br><span class="line">defaultZone: http:&#x2F;&#x2F;1.1.1.3:8000&#x2F;eureka&#x2F;,http:&#x2F;&#x2F;1.1.1.4:8000&#x2F;eureka&#x2F;</span><br></pre></td></tr></table></figure>
<h4 id="项目打包-8"><a href="#项目打包-8" class="headerlink" title="项目打包"></a>项目打包</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">mvn package</span><br></pre></td></tr></table></figure>
<h4 id="启动网关"><a href="#启动网关" class="headerlink" title="启动网关"></a>启动网关</h4><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">java -jar target&#x2F;spring-cloud-zuul-1.0.0.BUILD-SNAPSHOT.jar</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-213.png" alt="upload successful"></p>
<h3 id="打开节点二验证访问"><a href="#打开节点二验证访问" class="headerlink" title="打开节点二验证访问"></a>打开节点二验证访问</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">curl 1.1.1.3:8888&#x2F;producer&#x2F;hello?name&#x3D;zx</span><br><span class="line">hello zx，this is first messge</span><br></pre></td></tr></table></figure>
<blockquote>
<p>访问追踪首页<code>http://1.1.1.3:9000</code></p>
</blockquote>
<p><img src="/images/pasted-214.png" alt="upload successful"></p>
<h2 id="部署微服务监控"><a href="#部署微服务监控" class="headerlink" title="部署微服务监控"></a>部署微服务监控</h2><p>主要功能：对微服务的存活性进行检测并进行邮件报警<br>停掉所有微服务端口</p>
<h3 id="节点一-4"><a href="#节点一-4" class="headerlink" title="节点一"></a>节点一</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-boot-admin-eureka&#x2F;spring-cloud-eureka</span><br><span class="line">mvn spring-boot:run</span><br></pre></td></tr></table></figure>
<h3 id="开启另一个终端"><a href="#开启另一个终端" class="headerlink" title="开启另一个终端"></a>开启另一个终端</h3><p>部署生产者</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">source &#x2F;etc&#x2F;profile</span><br><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-boot-admin-eureka&#x2F;spring-cloud-producer</span><br><span class="line">mvn spring-boot:run</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-215.png" alt="upload successful"></p>
<h3 id="再次开启另一个终端"><a href="#再次开启另一个终端" class="headerlink" title="再次开启另一个终端"></a>再次开启另一个终端</h3><p>部署第二个生产者</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-boot-admin-eureka&#x2F;spring-cloud-producer-2</span><br><span class="line">mvn spring-boot:run</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-216.png" alt="upload successful"></p>
<p>打开浏览器搜索“qq邮箱”<br>登录2个邮箱<br>一个是发送邮件的<br>一个是接收邮件的<br>以下是：发送邮件的信箱的配置</p>
<p><img src="/images/pasted-217.png" alt="upload successful"></p>
<p><img src="/images/pasted-218.png" alt="upload successful"></p>
<p><img src="/images/pasted-219.png" alt="upload successful"><br>复制以上授权</p>
<h3 id="再次开启另一个终端-1"><a href="#再次开启另一个终端-1" class="headerlink" title="再次开启另一个终端"></a>再次开启另一个终端</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br></pre></td><td class="code"><pre><span class="line">cd &#x2F;usr&#x2F;local&#x2F;spring-cloud-examples&#x2F;spring-boot-admin-eureka&#x2F;spring-boot-admin-server</span><br><span class="line">vi src&#x2F;main&#x2F;resources&#x2F;application.yml</span><br><span class="line">修改</span><br><span class="line">  mail:   # 报警邮箱配置</span><br><span class="line">    host: smtp.qq.com     # 代表使用qq邮箱</span><br><span class="line">    username: 718334935@qq.com   # 填写自己qq邮箱</span><br><span class="line">    password: qwer asdf zxcv     # 授权码</span><br><span class="line">  boot:</span><br><span class="line">    admin:</span><br><span class="line">      notify:</span><br><span class="line">        mail:</span><br><span class="line">          from: 718334935@qq.com   # 发件人邮箱</span><br><span class="line">          to: 1244326151@qq.com   # 收件人邮箱</span><br><span class="line"></span><br><span class="line"># 构建并运行</span><br><span class="line">mvn spring-boot:run</span><br></pre></td></tr></table></figure>
<blockquote>
<p>访问<code>1.1.1.3:8080</code></p>
</blockquote>
<p><img src="/images/pasted-220.png" alt="upload successful"><br>接着去收件人的qq邮箱中可以查看到发件人发送的邮件</p>
<p><img src="/images/pasted-221.png" alt="upload successful"></p>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/02/24/Spring/">http://example.com/2021/02/24/Spring/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/02/25/Consul/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Consul微服务注册中心</div></div></a></div><div class="next-post pull-right"><a href="/2021/02/24/Jenkins/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Maven+Jenkins+Gitlab自动化部署</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-1"><a class="toc-link" href="#spring%E6%A1%86%E6%9E%B6"><span class="toc-number">1.</span> <span class="toc-text">spring框架</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#spring-boot"><span class="toc-number">1.1.</span> <span class="toc-text">spring boot</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#spring-cloud"><span class="toc-number">1.2.</span> <span class="toc-text">spring cloud</span></a></li></ol></li><li class="toc-item toc-level-1"><a class="toc-link" href="#%E7%BB%84%E4%BB%B6"><span class="toc-number">2.</span> <span class="toc-text">组件</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#spring-cloud-config"><span class="toc-number">2.1.</span> <span class="toc-text">spring cloud config</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#spring-cloud-bus"><span class="toc-number">2.2.</span> <span class="toc-text">spring cloud bus</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#spring-cloud-bus-1"><span class="toc-number">2.3.</span> <span class="toc-text">spring cloud bus</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#eureka"><span class="toc-number">2.4.</span> <span class="toc-text">eureka</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#consul"><span class="toc-number">2.5.</span> <span class="toc-text">consul</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#ribbon"><span class="toc-number">2.6.</span> <span class="toc-text">ribbon</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#feign"><span class="toc-number">2.7.</span> <span class="toc-text">feign</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#hystrix"><span class="toc-number">2.8.</span> <span class="toc-text">hystrix</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#zuul"><span class="toc-number">2.9.</span> <span class="toc-text">zuul</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#turbine"><span class="toc-number">2.10.</span> <span class="toc-text">turbine</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#Spring-Cloud-Starters"><span class="toc-number">2.11.</span> <span class="toc-text">Spring Cloud Starters</span></a></li></ol></li><li class="toc-item toc-level-1"><a class="toc-link"><span class="toc-number">3.</span> <span class="toc-text">端口信息</span></a></li><li class="toc-item toc-level-1"><a class="toc-link" href="#%E6%9C%8D%E5%8A%A1%E5%99%A8%E4%BF%A1%E6%81%AF"><span class="toc-number">4.</span> <span class="toc-text">服务器信息</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2maven"><span class="toc-number">4.1.</span> <span class="toc-text">部署maven</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2Eureka%E6%B3%A8%E5%86%8C%E4%B8%AD%E5%BF%83"><span class="toc-number">4.2.</span> <span class="toc-text">部署Eureka注册中心</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%A7%A3%E5%8E%8B%E8%BD%AF%E4%BB%B6%E5%8C%85"><span class="toc-number">4.2.1.</span> <span class="toc-text">解压软件包</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85"><span class="toc-number">4.2.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%9E%84%E5%BB%BA%E5%AE%8C%E4%B9%8B%E5%90%8E%E6%93%8D%E4%BD%9C"><span class="toc-number">4.2.3.</span> <span class="toc-text">构建完之后操作</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%89%93%E5%BC%80%E6%96%B0%E7%BB%88%E7%AB%AF"><span class="toc-number">4.2.4.</span> <span class="toc-text">打开新终端</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2Producer%E7%94%9F%E4%BA%A7%E8%80%85"><span class="toc-number">4.3.</span> <span class="toc-text">部署Producer生产者</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9HelloController%E6%96%87%E4%BB%B6"><span class="toc-number">4.3.1.</span> <span class="toc-text">修改HelloController文件</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-1"><span class="toc-number">4.3.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%BA%8C%E6%89%93%E5%BC%80%E6%96%B0%E7%BB%88%E7%AB%AF"><span class="toc-number">4.3.3.</span> <span class="toc-text">节点二打开新终端</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-2"><span class="toc-number">4.3.4.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E7%94%9F%E4%BA%A7%E5%92%8C%E6%B6%88%E8%B4%B9%E6%9E%84%E5%BB%BA%E5%AE%8C%E6%88%90%E6%89%A7%E8%A1%8C%E6%93%8D%E4%BD%9C"><span class="toc-number">4.3.5.</span> <span class="toc-text">生产和消费构建完成执行操作</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%94%BE%E8%A1%8C%E9%98%B2%E7%81%AB%E5%A2%99"><span class="toc-number">4.3.6.</span> <span class="toc-text">放行防火墙</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2Consumer%E6%B6%88%E8%B4%B9%E8%80%85"><span class="toc-number">4.4.</span> <span class="toc-text">部署Consumer消费者</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%B8%80"><span class="toc-number">4.4.1.</span> <span class="toc-text">节点一</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6"><span class="toc-number">4.4.1.1.</span> <span class="toc-text">修改配置文件</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-3"><span class="toc-number">4.4.1.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E8%BF%90%E8%A1%8C%E6%B6%88%E8%B4%B9%E8%80%85%EF%BC%8C%E5%BC%80%E5%90%AF9001%E7%AB%AF%E5%8F%A3"><span class="toc-number">4.4.1.3.</span> <span class="toc-text">运行消费者，开启9001端口</span></a></li></ol></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%BA%8C"><span class="toc-number">4.4.2.</span> <span class="toc-text">节点二</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E8%AE%BF%E9%97%AE%E6%B6%88%E8%B4%B9%E8%80%85%E7%AB%AF%E5%8F%A3"><span class="toc-number">4.4.2.1.</span> <span class="toc-text">访问消费者端口</span></a></li></ol></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2%E7%BD%91%E5%85%B3zuul"><span class="toc-number">4.5.</span> <span class="toc-text">部署网关zuul</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%B8%80-1"><span class="toc-number">4.5.1.</span> <span class="toc-text">节点一</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6-1"><span class="toc-number">4.5.1.1.</span> <span class="toc-text">修改配置文件</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-4"><span class="toc-number">4.5.1.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E8%BF%90%E8%A1%8C%E7%BD%91%E5%85%B38888%E7%AB%AF%E5%8F%A3"><span class="toc-number">4.5.1.3.</span> <span class="toc-text">运行网关8888端口</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E6%94%BE%E8%A1%8C%E9%98%B2%E7%81%AB%E5%A2%99-1"><span class="toc-number">4.5.1.4.</span> <span class="toc-text">放行防火墙</span></a></li></ol></li><li class="toc-item toc-level-3"><a class="toc-link"><span class="toc-number">4.5.2.</span> <span class="toc-text">刷新</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%BA%8C-1"><span class="toc-number">4.5.3.</span> <span class="toc-text">节点二</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E8%AE%BF%E9%97%AE%E7%BD%91%E5%85%B3%E7%AB%AF%E5%8F%A3"><span class="toc-number">4.5.3.1.</span> <span class="toc-text">访问网关端口</span></a></li></ol></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%A8%A1%E6%8B%9F%E6%95%85%E9%9A%9C"><span class="toc-number">4.5.4.</span> <span class="toc-text">模拟故障</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E6%96%AD%E6%8E%89%E8%8A%82%E7%82%B9%E4%BA%8C%E7%9A%849000%E7%AB%AF%E5%8F%A3%E7%9A%84%E7%94%9F%E4%BA%A7%E8%80%85"><span class="toc-number">4.5.4.1.</span> <span class="toc-text">断掉节点二的9000端口的生产者</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%BC%80%E5%90%AF%E8%8A%82%E7%82%B9%E4%BA%8C%E7%9A%849000%E7%AB%AF%E5%8F%A3"><span class="toc-number">4.5.4.2.</span> <span class="toc-text">开启节点二的9000端口</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%87%8D%E6%96%B0%E5%90%AF%E5%8A%A8%E6%B6%88%E8%B4%B9%E8%80%859001%E7%AB%AF%E5%8F%A3"><span class="toc-number">4.5.4.3.</span> <span class="toc-text">重新启动消费者9001端口</span></a></li></ol></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2hystrix%E7%86%94%E6%96%AD%E5%99%A8"><span class="toc-number">4.6.</span> <span class="toc-text">部署hystrix熔断器</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%B8%80%E4%BF%AE%E6%94%B9%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6"><span class="toc-number">4.6.1.</span> <span class="toc-text">节点一修改配置文件</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-5"><span class="toc-number">4.6.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%90%AF%E5%8A%A8%E7%86%94%E6%96%AD%E5%99%A8%EF%BC%88%E5%B8%A6%E6%9C%89%E7%86%94%E6%96%AD%E6%9C%BA%E5%88%B6%E7%9A%84%E6%B6%88%E8%B4%B9%E8%80%85%EF%BC%89"><span class="toc-number">4.6.3.</span> <span class="toc-text">启动熔断器（带有熔断机制的消费者）</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2zipkin%E9%93%BE%E8%B7%AF%E8%BF%BD%E8%B8%AA"><span class="toc-number">4.7.</span> <span class="toc-text">部署zipkin链路追踪</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6-2"><span class="toc-number">4.7.1.</span> <span class="toc-text">修改配置文件</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-6"><span class="toc-number">4.7.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%BC%80%E5%90%AFzipkin"><span class="toc-number">4.7.3.</span> <span class="toc-text">开启zipkin</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2%E7%94%9F%E4%BA%A7%E8%80%85"><span class="toc-number">4.7.4.</span> <span class="toc-text">部署生产者</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%B8%80-2"><span class="toc-number">4.7.4.1.</span> <span class="toc-text">节点一</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-7"><span class="toc-number">4.7.4.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%90%AF%E5%8A%A8%E7%94%9F%E4%BA%A7%E8%80%85"><span class="toc-number">4.7.4.3.</span> <span class="toc-text">启动生产者</span></a></li></ol></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2%E7%BD%91%E5%85%B3"><span class="toc-number">4.7.5.</span> <span class="toc-text">部署网关</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%B8%80-3"><span class="toc-number">4.7.5.1.</span> <span class="toc-text">节点一</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%A1%B9%E7%9B%AE%E6%89%93%E5%8C%85-8"><span class="toc-number">4.7.5.2.</span> <span class="toc-text">项目打包</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%90%AF%E5%8A%A8%E7%BD%91%E5%85%B3"><span class="toc-number">4.7.5.3.</span> <span class="toc-text">启动网关</span></a></li></ol></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%89%93%E5%BC%80%E8%8A%82%E7%82%B9%E4%BA%8C%E9%AA%8C%E8%AF%81%E8%AE%BF%E9%97%AE"><span class="toc-number">4.7.6.</span> <span class="toc-text">打开节点二验证访问</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2%E5%BE%AE%E6%9C%8D%E5%8A%A1%E7%9B%91%E6%8E%A7"><span class="toc-number">4.8.</span> <span class="toc-text">部署微服务监控</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%8A%82%E7%82%B9%E4%B8%80-4"><span class="toc-number">4.8.1.</span> <span class="toc-text">节点一</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%BC%80%E5%90%AF%E5%8F%A6%E4%B8%80%E4%B8%AA%E7%BB%88%E7%AB%AF"><span class="toc-number">4.8.2.</span> <span class="toc-text">开启另一个终端</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%86%8D%E6%AC%A1%E5%BC%80%E5%90%AF%E5%8F%A6%E4%B8%80%E4%B8%AA%E7%BB%88%E7%AB%AF"><span class="toc-number">4.8.3.</span> <span class="toc-text">再次开启另一个终端</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%86%8D%E6%AC%A1%E5%BC%80%E5%90%AF%E5%8F%A6%E4%B8%80%E4%B8%AA%E7%BB%88%E7%AB%AF-1"><span class="toc-number">4.8.4.</span> <span class="toc-text">再次开启另一个终端</span></a></li></ol></li></ol></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>